  public BWRange findBWRange() {
     BWRange bwr = new BWRange();

     int divergePoint = noOfMsgs+1;

     boolean notDiverge = true;
     boolean refNotFound = true;
     boolean abnormal = false;
     boolean foundFlag = false;

     double[] absGapDiffDirivative;
     int i;
     int k;
     int trend=1;
     int[] trendBeginPoint;
     int[] trendEndPoint;
     double[] ABWArray;
     double[] bandwidthReq;
     double variance=0.0;
     double stdVar;
//     int extremeLowPoint;

     trendBeginPoint = new int[noOfMsgs+1];
     trendEndPoint = new int[noOfMsgs+1];
     ABWArray = new double[noOfMsgs+1];
     bandwidthReq = new double[noOfMsgs+1];

     absGapDiffDirivative = new double[noOfMsgs+1];

     bandwidthReq[1] = curBWR.lowerBound;
     for(i=2; i<=sendingTime.length-1; i++)
        bandwidthReq[i] = msgSize/sendingTimeGap[i-1];

     try {

        i=1;
        while(i <= sendingTime.length-1 & alighFlag == false)  {
           System.out.println("absGapDiff["+i+"]"+absGapDifference[i]);
           if(absGapDifference[i] < -0.0002)  {
              alighFlag = true;
           }
           i++;
        }

        i = 1;
        while (i<=sendingTime.length-2 & refNotFound)  {   //if the points don't diverge until 10th packet, then refPkID = 10, divergePoint = 11

           for (k=1; k<=sendingTime.length-1; k++)  {
              absReceivingTimeGap[k] = receivingTime[k] - receivingTime[i];
              absSendingTimeGap[k] = sendingTime[k] - sendingTime[i];
              absGapDifference[k] = absReceivingTimeGap[k] - absSendingTimeGap[k];
           }
           if (absGapDifference[i+1] >= 0)  {
              k=i+1;
              while(k<=sendingTime.length-1 & refNotFound)  {
                 if(absGapDifference[k] > divergeThreshhold)  {
                    if(k <= sendingTime.length-2)   {   //to see whether the trend keep for at least 2 packets, if not, it's not a divergent point
                       if (absGapDifference[k+1] >= absGapDifference[k])   {
         //              divergePoint = k;
                          refNotFound = false;
                          refPkID = i;
                       }
                    }
                    else  {  //k=9 or 10
         //           divergePoint = k;
                       refNotFound = false;
                       refPkID = i;
                    }
                 }
                 k++;
              }
           }
           i++;
        }//end of while (i

        for(k=2; k<=sendingTime.length-1; k++)      //2, 10
           absGapDiffDirivative[k]=absGapDifference[k]-absGapDifference[k-1];

        trendBeginPoint[1] = refPkID;
        for(k=refPkID+1; k<=sendingTime.length-2; k++)  { //2, 9
           if(absGapDiffDirivative[k]>0 && absGapDiffDirivative[k+1] <= 0)  {   //trend finish
              trendEndPoint[trend] = k;
              trend++;
              trendBeginPoint[trend] = k+1;
           }
           if(k == sendingTime.length-2)
              trendEndPoint[trend] = k+1;
        }

        for(i=1; i<=trend; i++)  {
           net.println("trend "+i+" start from "+trendBeginPoint[i]+" and end at "+trendEndPoint[i]);
           notDiverge = true;
           k=trendBeginPoint[i];
           while(k<=trendEndPoint[i] & notDiverge)  {
              if(absGapDiffDirivative[k] > 0)   {
                 notDiverge = false;
                 divergePoint = k;
              }
              k++;
           }
           if(!notDiverge)   {
              net.println("Diverge Point="+divergePoint);
              for(k=trendBeginPoint[i]; k<=trendEndPoint[i]; k++)   {
                 if(divergePoint == 2)
                    ABWArray[k] = (curBWR.lowerBound+msgSize/sendingTimeGap[divergePoint-1])/2;
                 else
                    ABWArray[k] = ( msgSize/sendingTimeGap[divergePoint-2] + msgSize/sendingTimeGap[divergePoint-1] ) / 2;
              }
           }
           else  //only possible in the last trend
              net.println("NOt diverge in last trend, need another iteration.");

        }
      //  System.out.println("notDiverge="+notDiverge);

        if(refPkID > 1)   {  //handle the points before refPk
           for(i=1; i<=sendingTime.length-1; i++)
              net.println("absGapDifference["+i+"] = "+absGapDifference[i]);
           for(i=1; i<refPkID; i++)  {
              foundFlag = false;

              int nearestPoint1;
              int nearestPoint2;
              double abs, abs1;
              double ABW1, ABW2;

              k=trendBeginPoint[1];

              abs=java.lang.Math.abs(absGapDifference[i]-absGapDifference[k]);
              nearestPoint1 = trendBeginPoint[1];
              nearestPoint2 = trendBeginPoint[1];

              while(k<=trendEndPoint[trend]) {
                 abs1 = java.lang.Math.abs(absGapDifference[i]-absGapDifference[k]);
                 if(  abs1 < abs)  {
                    abs = abs1;
                    nearestPoint1 = nearestPoint2;
                    nearestPoint2 = k;
                 }
                 k++;
              }
              System.out.println("The absGapDifference of packet "+i+" is between "+nearestPoint1+" and "+nearestPoint2);
              ABW1=java.lang.Math.max( (ABWArray[nearestPoint1]-(bandwidthReq[nearestPoint1]-bandwidthReq[i])), 0.0);
              ABW2=java.lang.Math.max( (ABWArray[nearestPoint2]-(bandwidthReq[nearestPoint2]-bandwidthReq[i])), 0.0);
              ABWArray[i] = (ABW1+ABW2)/2;
         //     System.out.println("ABWArray["+k+"] = "+ABWArray[k]+", bandwidthReq["+k+"] = "+bandwidthReq[k]+", bandwidthReq["+i+"] = "+bandwidthReq[i]);
              net.println("ABWArray["+i+"] = "+ABWArray[i]);
           }  //end of for (i=1; i<refPkID
        }  //end of if(refPkID > 1)

        for(i=1;i<=sendingTime.length-1;i++)
           net.println("ABWArray["+i+"]="+ABWArray[i]);

        if (notDiverge)  {           //if the last trend is not diverged, that means the result is not valid
           bwr.upperBound = 2*curBWR.upperBound;
           bwr.lowerBound = curBWR.upperBound/2;
           reportValid = false;
           return bwr;
        }


        for(i=1; i<=sendingTime.length-1; i++)
           bwr.reportValue += (1/(sendingTime.length+0.0))*ABWArray[i];

        net.println("report Value = "+bwr.reportValue);


        for(i=1; i<=sendingTime.length-1; i++)
           variance += (ABWArray[i] - bwr.reportValue) * (ABWArray[i] - bwr.reportValue);
        stdVar = java.lang.Math.sqrt(variance/(sendingTime.length-2));

        bwr.accuracy = stdVar/bwr.reportValue;
        net.println("Accuracy is "+bwr.accuracy);

        i=1;
        foundFlag = false;
        while( i<=sendingTime.length-2 & foundFlag==false)   {
           if(bwr.reportValue>=bandwidthReq[i] & bwr.reportValue<bandwidthReq[i+1]) {
              foundFlag = true;

              if(i < 2)  bwr.lowerBound = bandwidthReq[1];

              else  bwr.lowerBound = bandwidthReq[i-1];

              if(i >= sendingTime.length-2) bwr.upperBound = bandwidthReq[sendingTime.length];

              else  bwr.upperBound = bandwidthReq[i+2];


           }
           i++;

        }

      } catch(ArrayIndexOutOfBoundsException e) {
         System.out.println("The Index Out of Range problem is in normal case"+e.toString());
      }
        return bwr;
  }